/*******************************************************************************
 * Copyright (c) 2011, 2012 IBM Corporation and others.
 *
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 *  The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 *  and the Eclipse Distribution License is available at
 *  http://www.eclipse.org/org/documents/edl-v10.php.
 *
 *  Contributors:
 *
 *	   Sam Padgett	       - initial API and implementation
 *     Michael Fiedler     - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.it.bcm;

import com.google.common.base.Strings;
import com.j2bugzilla.base.Bug;
import com.j2bugzilla.base.BugzillaConnector;
import com.j2bugzilla.base.BugzillaException;
import com.j2bugzilla.base.ConnectionException;
import com.j2bugzilla.base.Product;
import com.j2bugzilla.rpc.BugSearch;
import com.j2bugzilla.rpc.GetBug;
import com.j2bugzilla.rpc.GetProduct;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URLEncoder;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.TimeZone;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response.Status;
import org.eclipse.lyo.oslc4j.bugzilla.exception.UnauthorizedException;
import org.eclipse.lyo.oslc4j.bugzilla.jbugzx.rpc.GetAccessibleProducts;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.tools.store.ModelUnmarshallingException;
import org.eclipse.lyo.tools.store.Store;
import org.eclipse.lyo.tools.store.StoreAccessException;
import org.eclipse.lyo.tools.store.StoreFactory;
import org.eclipse.lyo.tools.store.update.OSLCMessage;
import org.eclipse.lyo.tools.store.update.StoreUpdateManager;
import org.eclipse.lyo.tools.store.update.change.HistoryResource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import se.kth.md.it.bcm.resources.BugzillaChangeRequest;
import se.kth.md.it.bcm.resources.Person;
import se.kth.md.it.bcm.servlet.CredentialsFilter;
import se.kth.md.it.bcm.servlet.ServiceProviderCatalogSingleton;
import se.kth.md.it.bcm.servlet.ServletListener;
import se.kth.md.it.bcm.update.BugzillaChangeProvider;
import se.kth.md.it.bcm.update.LastUpdateHandler;
import se.kth.md.it.bcm.update.SimpleHandler;

// Start of user code imports
// End of user code

// Start of user code pre_class_code
// End of user code

public class BugzillaCachedAdaptorManager {

	// Start of user code class_attributes
	private static final Logger log = LoggerFactory.getLogger(BugzillaCachedAdaptorManager
		.class);

	public final static String REALM = "Bugzilla";
	public static final String USER_DIR_PROPERTY = "user.dir";
	public static final String BUGZ_PROPERTIES_PATH = "/test/resources/bugz.properties";
	public static final String BUGZILLA_URI_KEY = "bugzilla_uri";
	public static final String BUGZILLA_URI_DEFAULT = "https://landfill.bugzilla" +
		".org/bugzilla-4.4-branch/";

	public static final String ADMIN_KEY = "admin";
	public static final String ADMIN_DEFAULT = "root@localhost";
	public static final String STORE_ENABLED_KEY = "storeEnabled";
	public static final String STORE_ENABLED_DEFAULT = "true";
	public static final String RUN_SPARQL_KEY = "runSparql";
	public static final String RUN_SPARQL_DEFAULT = "false";
	public static final String STORE_UPDATE_FREQUENCY_KEY = "storeUpdateFrequency";
	public static final String STORE_UPDATE_FREQUENCY_DEFAULT = "300";
	public static final String BUGZILLA_USERNAME_KEY = "bugzillaUsername";
	public static final String BUGZILLA_PASSWORD_KEY = "bugzillaPassword";
	public static final String LATEST_STORE_UPDATE_KEY = "latestStoreUpdate";
	public static final String LATEST_STORE_UPDATE_DEFAULT = "1970-01-01T00:01:00Z";
	public static final String LAST_UPDATE_KEY = "lyo://store/lastUpdate";

	private static String bugzillaUri = null;
	private static String admin = null;
	private static Properties properties;/**/
	private static Store store;
	private static Date lastStoreUpdate;
	private static int storeUpdateFrequency;
	private static String bugzillaUsername;
	private static String bugzillaPassword;
	private static BugzillaChangeProvider bugzillaChangeProvider;
	// End of user code


	// Start of user code class_methods
	public static String getBugzillaUri() {
		return bugzillaUri;
    }

	public static String getAdmin() {
		return admin;
	}

    /**
     * get BugzillaConnector from the HttpSession
     *
     * The connector should be placed in the session by the CredentialsFilter servlet filter
     *
     * @param request
     * @return connector
     */
	public static BugzillaConnector getBugzillaConnector(HttpServletRequest request)
	{
		//connector should never be null if CredentialsFilter is doing its job
		BugzillaConnector connector = (BugzillaConnector) request.getSession().getAttribute(CredentialsFilter.CONNECTOR_ATTRIBUTE);
		return connector;
	}

	//The following are static utility methods are useful for getting, creating and updating Bugzilla bugs.  Primarily used by BugzillaChangeRequestService

	public static BugzillaChangeRequest getBugzillaChangeRequestFromServer(HttpServletRequest httpServletRequest, final String productId, final String bugId) {
		BugzillaChangeRequest aResource = null;
		try {
	        Bug bug = BugzillaCachedAdaptorManager.getBugById(httpServletRequest, bugId);
	        if (bug != null) {
	        	aResource = BugzillaCachedAdaptorManager.fromBug(bug, httpServletRequest, productId);
	        }
		} catch (Exception e) {
			e.printStackTrace();
			throw new WebApplicationException(e,Status.INTERNAL_SERVER_ERROR);
		}
        return aResource;
	}

	public static BugzillaChangeRequest getBugzillaChangeRequestFromServer(BugzillaConnector bugzillaConnector,
		final String
		productId, final String bugId) {
		BugzillaChangeRequest aResource = null;
		try {
			Bug bug = BugzillaCachedAdaptorManager.getBug(bugzillaConnector, Integer.valueOf(bugId));
			if (bug != null) {
				aResource = BugzillaCachedAdaptorManager.fromBug(bug, bugzillaConnector, productId);
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new WebApplicationException(e,Status.INTERNAL_SERVER_ERROR);
		}
		return aResource;
	}

	private static Bug getBug(final BugzillaConnector bc, final int bugId)
		throws BugzillaException {
		final Bug bug;
		final GetBug getBug = new GetBug(bugId);
		bc.executeMethod(getBug);
		bug = getBug.getBug();
		return bug;
	}

	/**
	 * Converts a {@link Bug} to an OSLC-CM BugzillaChangeRequest.
	 *
	 * @param bug
	 *            the bug
	 * @return the ChangeRequest to be serialized
	 * @throws URISyntaxException
	 *             on errors setting the bug URI
	 * @throws UnsupportedEncodingException
	 */
	@Deprecated
	public static BugzillaChangeRequest fromBug(Bug bug, final HttpServletRequest httpServletRequest, final String serviceProviderId)
			throws URISyntaxException, UnsupportedEncodingException {
		BugzillaConnector bugzillaConnector = getBugzillaConnector(httpServletRequest);
		return fromBug(bug, bugzillaConnector, serviceProviderId);
	}

	public static BugzillaChangeRequest fromBug(Bug bug, final BugzillaConnector bugzillaConnector, final String
		serviceProviderId)
		throws URISyntaxException, UnsupportedEncodingException {
		BugzillaChangeRequest changeRequest = new BugzillaChangeRequest();
		changeRequest.setIdentifier(Integer.toString(bug.getID()));
		changeRequest.setTitle(bug.getSummary());
		changeRequest.setStatus(bug.getStatus());

		//Map contributor to the person this bug is assigned to
		Object assignedTo = bug.getParameterMap().get("assigned_to");
		if (assignedTo != null) {
			String email = assignedTo.toString();
			Person contributor = new Person();
			//contributor.setMbox(email);
			contributor.setAbout(new URI(ServletListener.getServletBase() + "/person?mbox=" + URLEncoder.encode(email, "UTF-8")));
			HashSet<Person> contributors = new HashSet<Person>();
			contributors.add(contributor);
			changeRequest.setContributor(contributors);
		}

		Date createdDate = (Date) bug.getParameterMap().get("creation_time");
		changeRequest.setCreated(createdDate);

		Date modifiedDate = (Date) bug.getParameterMap().get("last_change_time");
		changeRequest.setModified(modifiedDate);

		changeRequest.setProduct(bug.getProduct());
		changeRequest.setComponent(bug.getComponent());

		// Work around a bug in j2bugzilla. Bug.getVersion() results in a class cast exception.
		Object version = bug.getParameterMap().get("version");
		if (version != null) {
			changeRequest.setVersion(version.toString());
		}

		changeRequest.setPriority(bug.getPriority());

		Map<?, ?> internals = bug.getParameterMap();
		changeRequest.setPlatform((String) internals.get("platform"));
		changeRequest.setOperatingSystem((String) internals.get("op_sys"));

		changeRequest.setServiceProvider(ServiceProviderCatalogSingleton.getServiceProvider(bugzillaConnector,
			serviceProviderId).getAbout());
		changeRequest.setAbout(BugzillaChangeRequest.constructURI(serviceProviderId, changeRequest.getIdentifier()));

		return changeRequest;
	}

    /**
     * Convert a list of Bugzilla Bugs to a list of BugzillaChangeRequests
     *
     * @param httpServletRequest
     * @param bugList
     * @return
     */
	public static List<BugzillaChangeRequest> changeRequestsFromBugList(final HttpServletRequest httpServletRequest, final List<Bug> bugList, final String serviceProviderId)
    {
    	List<BugzillaChangeRequest> results = new ArrayList<BugzillaChangeRequest>();

        for (Bug bug : bugList) {
        	BugzillaChangeRequest changeRequest = null;
        	try {
        		changeRequest = BugzillaCachedAdaptorManager.fromBug(bug, httpServletRequest, serviceProviderId);
        	} catch (Exception e) {
        		throw new WebApplicationException(e);
        	}

        	if (changeRequest != null) {
        		results.add(changeRequest);
        	}
        }
        return results;
    }

	/**
	 * Create a list of Bugs for a product ID using paging
	 *
	 * @param httpServletRequest
	 * @param productIdString
	 * @param page
	 * @param limit
	 * @return The list of bugs, paged if necessary
	 * @throws IOException
	 * @throws ServletException
	 */
	public static List<Bug> getBugsByProduct(final HttpServletRequest httpServletRequest, final String productIdString, int page, int limit) throws IOException, ServletException
    {
    	List<Bug> results=null;



		try {
			final BugzillaConnector bc = BugzillaCachedAdaptorManager.getBugzillaConnector(httpServletRequest);
			final String pageString = httpServletRequest.getParameter("page");

			if (null != pageString) {
				page = Integer.parseInt(pageString);
			}
			int productId = Integer.parseInt(productIdString);

			final GetProduct getProducts = new GetProduct(productId);
			bc.executeMethod(getProducts);
			final Product product = getProducts.getProduct();

			final BugSearch bugSearch = createBugSearch(page, limit, product);
			bc.executeMethod(bugSearch);
			results = bugSearch.getSearchResults();
		} catch (Exception e) {
			e.printStackTrace();
			throw new WebApplicationException(e);
		}

    	return results;
    }

	protected static BugSearch createBugSearch(int page, int limit, Product product) {
		BugSearch.SearchQuery productQuery = new BugSearch.SearchQuery(
				BugSearch.SearchLimiter.PRODUCT, product.getName());
		BugSearch.SearchQuery limitQuery = new BugSearch.SearchQuery(
				BugSearch.SearchLimiter.LIMIT, (limit + 1) + "");  // TODO: 2016-12-28 fix!
		BugSearch.SearchQuery offsetQuery = new BugSearch.SearchQuery(
				BugSearch.SearchLimiter.OFFSET, (page * limit) + "");

		return new BugSearch(productQuery, limitQuery, offsetQuery);
	}

	/**
	 * Get a Bugzilla Bug by id
	 * @param request
	 * @param bugIdString
	 * @return Bug
	 * @throws IOException
	 * @throws ServletException
	 */
	public static Bug getBugById(final HttpServletRequest request, final String bugIdString) throws IOException, ServletException
	{
		int bugId = -1;
		Bug bug = null;

		try {
			bugId = Integer.parseInt(bugIdString);
			final BugzillaConnector bc = BugzillaCachedAdaptorManager.getBugzillaConnector(request);
			bug = getBug(bc, bugId);
			if (bug == null) {
				throw new WebApplicationException(Status.NOT_FOUND);
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new WebApplicationException(e);
		}

		return bug;
	}

	protected static void addLinkComment(final StringBuffer buffer, final String linkType, final Link [] links) {
		if (links != null && (links.length !=0)) {
			buffer.append(linkType);
			buffer.append(":\n\n");
			for (Link link : links) {
				buffer.append(link.getValue().toString());
				buffer.append("\n");
			}
		}
	}

	/**
	 * Loads Bugzilla adaptor properties from the filesystem.
	 */
	private static void loadBugzillaProperties() {
//		String dir = System.getProperty(USER_DIR_PROPERTY);
//		String propertiesFilename = dir + BUGZ_PROPERTIES_PATH;
//		try {
//			properties = loadBugzillaPropertiesFrom(propertiesFilename);
//		} catch (FileNotFoundException e) {
//			e.printStackTrace();
//		}
		final InputStream stream = BugzillaCachedAdaptorManager.class.getResourceAsStream(
			"/bugz.properties");
		properties = loadBugzillaPropertiesFromStream(stream);
	}

	/**
	 * Loads Bugzilla adaptor properties from the filesystem.
	 */
	private static Properties loadBugzillaPropertiesFrom(final String propertiesFilename)
		throws FileNotFoundException {
		// bugz.properties file is placed out of package of BugzillaAdaptorManager,
		// getResourceAsStream can't be used. FileInputStream is used instead.
		try {
			FileInputStream propertyFilePath = new FileInputStream(propertiesFilename);
			Properties properties = loadBugzillaPropertiesFromStream(propertyFilePath);
			log.info("Loaded Bugzilla settings from '{}' properties file", propertiesFilename);
			return properties;
		} catch (FileNotFoundException e) {
			log.error("Failed to load Bugzilla settings from '{}' properties file",
				propertiesFilename);
			throw e;
		}
	}

	private static Properties loadBugzillaPropertiesFromStream(final InputStream
		propertyFilePath) {
		Properties props = new Properties();
		try {
			props.load(propertyFilePath);
		} catch (Exception e) {
			log.error("Failed to parse Bugzilla properties from stream");
		}
		return props;
	}

	private static void configureBugzillaInfo(final Properties props) {
		bugzillaUri = props.getProperty(BUGZILLA_URI_KEY, BUGZILLA_URI_DEFAULT);
		bugzillaUri = normalizeUri(bugzillaUri);
		admin = props.getProperty(ADMIN_KEY, ADMIN_DEFAULT);
		logConfigurationProperty(BUGZILLA_URI_KEY, BugzillaCachedAdaptorManager.bugzillaUri);
		logConfigurationProperty(ADMIN_KEY, BugzillaCachedAdaptorManager.admin);
	}

	private static void logConfigurationProperty(final String property, final String
		value) {
		log.info("Property {}='{}'", property, value);
	}

	/**
	 * Normalizes the URI so it never ends with '/'
	 * @param uri URI (not null, may be already normalised)
	 * @return normalized uri unless null is supplied
	 */
	private static String normalizeUri(String uri) {
		if (uri != null && uri.endsWith("/")) {
			return uri.substring(0, uri.length() - 1);
		}
		return uri;
	}

	private static void parseLastStoreUpdate() {
		String someUpdateDate = properties.getProperty(LATEST_STORE_UPDATE_KEY,
			LATEST_STORE_UPDATE_DEFAULT);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
		dateFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
		try {
			lastStoreUpdate = dateFormat.parse(someUpdateDate);
			logConfigurationProperty(LATEST_STORE_UPDATE_KEY, lastStoreUpdate.toString());
		} catch (ParseException e) {
			log.warn("Failed to parse the last update date from '{}'", someUpdateDate);
		}
	}

	private static void initializeStore(final boolean runSparql) {
		final String sparqlQueryEndpoint;
		final String sparqlUpdateEndpoint;
		final String tdbDataDir;
		if (runSparql) {
			sparqlQueryEndpoint = properties.getProperty("sparqlQueryEndpoint");
			sparqlUpdateEndpoint = properties.getProperty("sparqlUpdateEndpoint");
			try {
				store = StoreFactory.sparql(sparqlQueryEndpoint, sparqlUpdateEndpoint);
			} catch (IOException e) {
				log.error("Failed to initialise Store (SPARQL endpoints: {} (query), {} " + "" +
					"(update))", sparqlQueryEndpoint, sparqlUpdateEndpoint);
			}
		} else {
			tdbDataDir = properties.getProperty("tdbDataDir");
			if (tdbDataDir != null) {
				Path baseDir = Paths.get(tdbDataDir);
				log.debug("triplestore.dir: {}", baseDir);
				store = StoreFactory.onDisk(baseDir);
			} else {
				store = StoreFactory.inMemory();
			}
		}
	}

	public static ServiceProviderInfo[] getServiceProviderInfos(BugzillaConnector bugzillaConnector)
	{
		ServiceProviderInfo[] serviceProviderInfos;
		try {
			GetAccessibleProducts getProductIds = new GetAccessibleProducts();
			bugzillaConnector.executeMethod(getProductIds);
			Integer[] productIds = getProductIds.getIds();
			serviceProviderInfos = new ServiceProviderInfo [productIds.length];
			ServiceProviderInfo serviceProviderInfo;
			int index = 0;
			for (Integer p : productIds) {
				serviceProviderInfo = new ServiceProviderInfo();
				//Check the original Lyo labs to see how one can extract the product name here.
				GetProduct getProductMethod = new GetProduct(p);
				bugzillaConnector.executeMethod(getProductMethod);
				serviceProviderInfo.name = getProductMethod.getProduct().getName();
				//serviceProviderInfo.name = "Some Name";
				serviceProviderInfo.serviceProviderId = Integer.toString(p);
				serviceProviderInfos[index] = serviceProviderInfo;
				index++;
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new WebApplicationException(e,Status.INTERNAL_SERVER_ERROR);
		}
		return serviceProviderInfos;
	}

	private static <T> List<T> slicePaging(List<T> resources, int page, int limit) {
		if (limit <= 0) {
			return resources;
		}
		int fromIndex = page * limit;
		// override due to a bug in service that determines paging flag,
		// it removes the last element if there are more than 'limit' records
		int limitIndex = fromIndex + limit + 1; // TODO: 2016-12-26 remove +1 workaround
		int toIndex = Math.min(limitIndex, resources.size());
		log.debug("Creating a slice [{},{}] on a list of {} elements", fromIndex, toIndex,
			resources.size());
		// because service calls .remove() method that is not defined on some immutable implementations
		// TODO: 2016-12-25 fix in the generator to call subList(0, size-1)
		return new ArrayList<>(resources.subList(fromIndex, toIndex));
	}
	// End of user code

    public static void contextInitializeServletListener(final ServletContextEvent servletContextEvent)
    {
		// TODO Implement code to establish connection to data backbone etc ...

		// Start of user code contextInitializeServletListener
		loadBugzillaProperties();

		configureBugzillaInfo(properties);

		final boolean storeEnabled = initialiseStore();

		if (storeEnabled) {
			try {
				bugzillaChangeProvider = new BugzillaChangeProvider(bugzillaUsername,
					bugzillaPassword);
				// TODO: 2016-12-27 pass last update timestamp to changeprovider
				StoreUpdateManager<OSLCMessage> updateManager = new StoreUpdateManager<>(store,
					bugzillaChangeProvider);
				updateManager.addHandler(new SimpleHandler());
				updateManager.addHandler(new LastUpdateHandler<>(LAST_UPDATE_KEY));
				ZonedDateTime lastUpdateDate = getLastUpdateDate();
				updateManager.poll(lastUpdateDate, storeUpdateFrequency);
			} catch (ConnectionException | UnauthorizedException e) {
				log.error(
					"Failed to initialize BugzillaChangeProvider w/login '{}' (using password: {})",
					bugzillaUsername,
					new Object[]{Strings.isNullOrEmpty(bugzillaPassword) ? "NO" : "YES", e});
			}
		}
		// End of user code
	}

	private static ZonedDateTime getLastUpdateDate() {
		if (store.containsKey(LAST_UPDATE_KEY)) {
			try {
				HistoryResource historyResource = store.getResources(LAST_UPDATE_KEY,
					HistoryResource.class).get(0);
				ZonedDateTime since = ZonedDateTime.ofInstant(
					historyResource.getTimestamp().toInstant(), ZoneId.systemDefault());
				log.info("Instructing StoreUpdateManager to request changes since {}", since);
				return since;
			} catch (StoreAccessException | ModelUnmarshallingException e) {
				log.error("Failed to fetch last update date from the store", e);
			}
		} else {
			log.warn("Starting a full update, the was no information under '{}' key",
				LAST_UPDATE_KEY);
		}
		return null;  // TODO: 2016-12-29 refactor
	}

	private static boolean initialiseStore() {
		final boolean storeEnabled = Boolean.valueOf(
			properties.getProperty(STORE_ENABLED_KEY, STORE_ENABLED_DEFAULT));
		logConfigurationProperty(STORE_ENABLED_KEY, String.valueOf(storeEnabled));
		if (storeEnabled) {
			final boolean runSparql = Boolean.valueOf(
				properties.getProperty(RUN_SPARQL_KEY, RUN_SPARQL_DEFAULT));
			logConfigurationProperty(RUN_SPARQL_KEY, String.valueOf(runSparql));
			initializeStore(runSparql);
			storeUpdateFrequency = Integer.valueOf(properties.getProperty(STORE_UPDATE_FREQUENCY_KEY,
				STORE_UPDATE_FREQUENCY_DEFAULT));

			parseLastStoreUpdate();

			bugzillaUsername = properties.getProperty(BUGZILLA_USERNAME_KEY);
			bugzillaPassword = properties.getProperty(BUGZILLA_PASSWORD_KEY);
		} else {
			log.warn("Store is not enabled");
		}
		return storeEnabled;
	}

	public static void contextDestroyServletListener(ServletContextEvent servletContextEvent)
	{
		// TODO Implement code to shutdown connections to data backbone etc...

		// Start of user code contextDestroyed
		// End of user code
	}

	public static ServiceProviderInfo[] getServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
		ServiceProviderInfo[] serviceProviderInfos = {};
		// TODO Implement code to return the set of ServiceProviders

		// Start of user code "ServiceProviderInfo[] getServiceProviderInfos(...)"
		BugzillaConnector bc = BugzillaCachedAdaptorManager.getBugzillaConnector(httpServletRequest);
		serviceProviderInfos = getServiceProviderInfos(bc);
		// End of user code
		return serviceProviderInfos;
    }

    public static List<BugzillaChangeRequest> queryBugzillaChangeRequests(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
		List<BugzillaChangeRequest> resources = null;
		// TODO Implement code to return a set of resources

		// Start of user code queryBugzillaChangeRequests
		try {
			if(store.containsKey(serviceProviderId)) {
				resources = store.getResources(serviceProviderId, BugzillaChangeRequest.class);
				resources = slicePaging(resources, page, limit);
			} else {
				try {
					List<Bug> bugList = BugzillaCachedAdaptorManager.getBugsByProduct(
						httpServletRequest, serviceProviderId, page, limit);
					resources = BugzillaCachedAdaptorManager.changeRequestsFromBugList(
						httpServletRequest, bugList, serviceProviderId);
				} catch (IOException | ServletException e) {
					log.error("Failed to fetch bugz from Bugzilla instance", e);
				}
			}
		} catch (StoreAccessException e) {
			log.error("Failed to retrieve ChangeRequests from the store", e);
		} catch (ModelUnmarshallingException e) {
			log.error("Failed to unmarshal ChangeRequests from the store", e);
		}

		// End of user code
		return resources;
    }


	public static BugzillaChangeRequest getBugzillaChangeRequest(HttpServletRequest httpServletRequest, final String serviceProviderId, final String bugzillaChangeRequestId)
    {
		BugzillaChangeRequest aResource = null;
		// TODO Implement code to return a resource

		// Start of user code getBugzillaChangeRequest
		try {
			String uri = BugzillaChangeRequest.constructURI(serviceProviderId, bugzillaChangeRequestId)
				.toString();
			if (store.containsKey(uri)) {
				List<BugzillaChangeRequest> resources = store.getResources
					(uri, BugzillaChangeRequest.class);
				aResource = resources.get(0);
				log.trace("{} resources were present in the triplestore (size={})", uri,
					resources.size());
			} else {
				aResource = getBugzillaChangeRequestFromServer(httpServletRequest, serviceProviderId,
					bugzillaChangeRequestId);
				// TODO test with a single-argument method
				store.putResources(uri, aResource);
			}
		} catch (Exception e) {
			log.error(String.valueOf(e));
		}
		// End of user code
		return aResource;
    }

	public static String getETagFromBugzillaChangeRequest(final BugzillaChangeRequest aResource)
    {
		String eTag = null;
		// TODO Implement code to return an ETag for a particular resource
		// Start of user code getETagFromBugzillaChangeRequest
    	Long eTagAsTime = null;

    	if (aResource.getModified() != null) {
    		eTagAsTime = aResource.getModified().getTime();
    	} else if (aResource.getCreated() != null) {
    		eTagAsTime = aResource.getCreated().getTime();
    	} else {
    		eTagAsTime = new Long(0);
    	}
		eTag = eTagAsTime.toString();
		// End of user code
		return eTag;
    }
}
